#!/usr/bin/python3
import sys
import os
import time
import shutil
import subprocess
import logging

# TODO Have to reliably import to use it here ...
# logger = init_logger('updater', fmt='%(name)-9s %(asctime)s %(levelname)-8s %(message)s', to_console=True, log_to='siwim_i')
console = logging.StreamHandler()
console.setLevel(logging.DEBUG)
console.setFormatter(logging.Formatter(fmt='%(name)-9s %(asctime)s %(levelname)-8s %(message)s', datefmt='%Y-%m-%d %H:%M:%S'))
logging.getLogger('i_updater').addHandler(console)

logger = logging.getLogger('i_updater')
handler = logging.FileHandler('log/{0}_siwim_i.log'.format(time.strftime('%Y-%m-%d')))
handler.setFormatter(logging.Formatter(fmt='%(name)-9s %(asctime)s %(levelname)-8s [%(filename)s: %(lineno)d] %(message)s', datefmt='%H:%M:%S'))
logger.addHandler(handler)
logger.setLevel(logging.INFO)

try:
  #from ctypes import *
  if sys.platform == "win32":
    from ctypes.wintypes import DWORD
    from ctypes import sizeof, byref, windll
    n = 0
    def EnumProcesses():
      #res = {}
      ProcessIds = (DWORD*256)()
      cb = sizeof(ProcessIds)
      BytesReturned = DWORD()
      #PROCESS_QUERY_INFORMATION = 0x0400
      windll.psapi.EnumProcesses(byref(ProcessIds), cb, byref(BytesReturned))
      nReturned = BytesReturned.value / sizeof(DWORD)
      pidProcess = [i for i in ProcessIds][:int(nReturned)]
      return pidProcess
    def pid_exists(pid):
      return pid in EnumProcesses()
    while n < 30:
      try:
        if not pid_exists(int(sys.argv[1])):
          update_files = os.listdir("update")
          for update_file in update_files:
            if update_file == "conf.xml":
              shutil.copyfile("update/conf.xml", "conf/conf.xml")
            else:
              if update_file != "i_updater.py":
                shutil.copyfile("update/" + update_file, update_file)
            if update_file != "i_updater.py":
              os.remove("update/" + update_file)        
          time.sleep(10)
          logger.info('Restarting siwim_i.py...')
          # if len(sys.argv) > 2 and sys.argv[2] == 'debug':
          #   logger.debug('Running siwim_i.py in debug mode.')
          #   subprocess.Popen([sys.executable, 'siwim_i.py', 'debug'], close_fds=True)
          # else:
          subprocess.Popen([sys.executable, 'siwim_i.py'], close_fds=True)
          break
        else:
          time.sleep(5)
      except Exception as ex:
        logger.exception("Error in inner loop:")
        break
      n+=1
  elif sys.platform == "linux" or sys.platform == "linux2":
    update_files = os.listdir("update")
    for update_file in update_files:
      if update_file == "conf.xml":
        shutil.copyfile("update/conf.xml", "conf/conf.xml")
      else:
        if update_file != "i_updater.py":
          shutil.copyfile("update/" + update_file, update_file)
      if update_file != "i_updater.py":
        os.remove("update/" + update_file)
except Exception:
  logger.exception("Update failed:")
